"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const listener = __importStar(require("./wsListener"));
const auth_1 = require("./auth");
const orderService = __importStar(require("./orderService"));
const orderStore = __importStar(require("./orderStore"));
require('dotenv').config();
function init() {
    return __awaiter(this, void 0, void 0, function* () {
        // listener is responsible for receiving orders from Ordering Stack
        const ctx = {
            TENANT: process.env.TENANT,
            VENUE: process.env.VENUE,
            BASE_URL: process.env.BASE_URL,
        };
        let refreshToken = '';
        const refreshTokenHandler = {
            getRefreshToken: () => refreshToken,
            setRefreshToken: (_refreshToken) => {
                refreshToken = _refreshToken;
            },
        };
        const params = {
            baseURL: '',
            tenant: ctx.TENANT,
            venue: ctx.VENUE,
            authDataProvider: auth_1.authDataProvider,
            refreshTokenHandler,
            onConnectedAsync: (accessToken) => __awaiter(this, void 0, void 0, function* () {
                console.log('ws connected!');
                const orders = yield orderService.pullOrders(ctx, ctx.VENUE, accessToken);
                for (const order of orders) {
                    orderStore.onOrderUpdate(order);
                }
            }),
            onDisconnectAsync: () => __awaiter(this, void 0, void 0, function* () {
                console.log('ws disconnected');
            }),
            onKDSMessageAsync: (message) => __awaiter(this, void 0, void 0, function* () {
                console.log(`MESSAGE  order [${message.id}]`);
                orderStore.onOrderUpdate(message);
            }),
            onOrdersUpdateAsync: (order) => __awaiter(this, void 0, void 0, function* () {
                console.log(`new or updated order [${order.id}]`);
                orderStore.onOrderUpdate(order);
            }),
            onNotificationAsync: (message) => __awaiter(this, void 0, void 0, function* () {
                orderStore.onOrderError(message);
                console.log(`NOTIFICATION: ${JSON.stringify(message)}`);
            }),
            onAuthFailure: () => __awaiter(this, void 0, void 0, function* () {
                console.log('------------- MANUAL AUTH REQUIRED ----------------- ');
            }),
        };
        listener.connectWebSockets(params);
    });
}
module.exports = {
    listener,
    orderStore,
};
